<template>
  <tr v-if="columns">
    <td class="px-2 py-1 lg:px-4">
      <div v-if="!point._hidden" class="flex justify-center w-full">
        <button
          title="Click and hold to be able to move the line, which will change it's number"
          id="dragula"
          class="flex p-1 rounded-full cursor-move hover:text-blue-500 dark:hover:text-blue-400"
        >
          <IconBase id="dragula" name="menu" size="16" />
        </button>
      </div>
    </td>
    <td class="px-1 py-1 text-sm lg:px-4">
      <p v-bind:class="{ invisible: point._hidden }" class="text-center">
        <b>
          {{ point.getNumber() }}
        </b>
      </p>
    </td>
    <td
      v-bind:key="key"
      v-for="(value, key) in columns"
      v-bind:class="{ 'opacity-50': point._hidden }"
      class="px-1 py-1 text-sm text-right lg:px-4"
    >
      <p
        v-if="project.reports.current.values.current === value"
        v-bind:style="{ color: genColor() }"
        class="font-black text-right"
      >
        {{
          point.values[value].kind === 'unit'
            ? point.values[value].value.toDisplayedNumber().toString() === 'NaN'
              ? 'KO'
              : value === 'Portance'
              ? getPortance(point.values[value].value.toDisplayedNumber().toString())
              : point.values[value].value.toDisplayedNumber().toString()
            : point.values[value].value
            ? point.values[value].value
            : '-'
        }}
      </p>
      <p v-else class="text-right">
        {{
          point.values[value].kind === 'unit'
            ? point.values[value].value.toDisplayedNumber().toString() === 'NaN'
              ? 'KO'
              : value === 'Portance'
              ? getPortance(point.values[value].value.toDisplayedNumber().toString())
              : point.values[value].value.toDisplayedNumber().toString()
            : point.values[value].value
            ? point.values[value].value
            : '-'
        }}
      </p>
    </td>
    <td class="px-2 py-1 lg:px-4">
      <div class="flex justify-center w-full">
        <button
          title="Click here to hide the point on the map"
          v-on:click="togglePoint"
          class="flex p-1 rounded-full hover:text-blue-500 dark:hover:text-blue-400"
        >
          <IconBase v-bind:name="point._hidden ? 'eyeOff' : 'eye'" size="16" />
        </button>
      </div>
    </td>
  </tr>
</template>

<script lang="ts">
  import { Component, Prop, Vue } from 'vue-property-decorator'
  import { State } from 'vuex-class'

  import * as Numeral from 'numeral'

  import IconBase from '@/components/IconBase.vue'

  import { Point } from '@/ts/point'
  import { Project } from '@/ts/project'
  import { Factory } from '@/ts/factory'
  import { blend } from '@/ts/utils/blender'

  @Component({
    components: {
      IconBase
    }
  })
  export default class C extends Vue {
    @State('factory')
    private factory!: Factory

    @State('project')
    private project!: Project

    @Prop()
    private point!: Point

    @Prop()
    private columns!: string[]

    private async togglePoint() {
      if (this.project.reports.current) {
        this.project.reports.current.points.hide(this.point)
        this.project.update()
      }
    }

    private genColor(): string {
      if (window.matchMedia('(prefers-color-scheme: dark)').matches) {
        return this.point.getColor()
      } else {
        return blend(this.point.getColor(), '#000000', 0.3)
      }
    }

    private getPortance(portanceString: string): string {
      const portance = Number(portanceString.replace(',', '.').replace(/\s/g, ''))

      return String(
        portance < this.factory.database.ParamsPortance.MinPortance.value
          ? '< ' + this.factory.database.ParamsPortance.MinPortance.value
          : portance > this.factory.database.ParamsPortance.MaxPortance.value
          ? '> ' + this.factory.database.ParamsPortance.MaxPortance.value
          : portanceString
      )
    }
  }
</script>
